% Demos aula 04
% Enhancement
clear all, close all
echo on
% 1. carrega imagem
[xi,ind]=imread('p64.bmp');
[nh,nv]=size(xi);  % tamamnho da imagem
x=ind2gray(xi,ind);  % intervalo [0 255]
figure(1),
imshow(x),title('original image')
posi=get(1,'position'); % a 1 x 4 vector gives lower left corner and size of image
set(1,'position',[0 540 posi(3:4)])

% Negativo da Imagem:  T(r) = L-1-r   L=256
pause
%
xneg=255-x;
figure(2),imshow(xneg),title('negativo da imagem')
posi=get(2,'position'); % a 1 x 4 vector gives lower left corner and size of image
set(2,'position',[160 540 posi(3:4)])

pause
% considerando outra transformação
%
r=[0:0.01:1]; 
s=[0.5*r(find(r<0.2)) 0.1+1.5*(r(find(0.2 <= r & r <= 0.7))-0.2)...
    1+0.5*(r(find(r>0.7))-1)];
figure(7),subplot(131),plot(r,s,'-'),title('mid-range strech')
set(7,'position',[275   265   712   194])
%
x1=double(x)/255; % normalizando x para o intervalo [0,1]
y=(0.5*x1).*[x1<0.2]+(0.1+1.5*(x1-0.2)).*[0.2 <= x1 & x1 <= 0.7] ...
    +(1+0.5*(x1-1)).*[x1 > 0.7];
%[xmid,indy]=cmunique(y);
figure(3),imshow(y),title('mid-range stretched')
%figure(3),imshow(xmid,indy),title('mid-range stretched')
posi=get(3,'position'); 
set(3,'position',[320 540 posi(3:4)])
pause

c = 255/log10(1+255); 
% c é escolhido de forma que apenas 256 niveis de cinza existam apos a
% transformada
r=[0:255]; s=c*log10(1+abs(r));
figure(7),subplot(132),plot(r,s,'-'),title('logarithm compression')
axis([0 256 0 256])

xlog=uint8(round(c*log10(1+double(x)))); 
figure(4),imshow(xlog),title('log-transformed')
posi=get(4,'position'); 

set(4,'position',[480 540 posi(3:4)]),

pause
%
% fatiamento das intensidades
%
r=[0:0.01:1];  s=r.*[r < 0.2 | r > .4] + .6*[0.2 <= r & r <=0.4];
figure(7),subplot(133),plot(r,s,'-'),title('intensity slicing')

y=x1.*[x1 < 0.2 | x1 > 0.4] + 0.6*[0.2 <= x1 & x1 <=0.4];
%[xints,indy]=cmunique(y);
%figure(5),imshow(xints,indy),title('intensity sliced')
figure(5),imshow(y),title('mid-range stretched')
posi=get(5,'position'); 
set(5,'position',[640 540 posi(3:4)]),pause
%
% dando uma olhada no histograma
[N,grayscale]=imhist(x); 
figure(8),set(8,'position',[5    40   560   420])
subplot(211),
stem(grayscale,N),title('histograma da imagem original')
axis([0 256 0 max(N)])
pause

% equalizando o histograma
xeq=histeq(x); 

figure(6),imshow(uint8(xeq)),title('histograma equalizado')
posi=get(6,'position');
set(6,'position',[800 540 posi(3:4)]),pause

[N,grayscale]=imhist(uint8(xeq));
figure(8),
subplot(212),stem(grayscale,N),title('equalized histogram')
axis([0 256 0 max(N)])
% veja que o histograma nao eh uniforme

