% Demo para processamento de imagens
% utilizando a imagem 'lena.bmp' 
% Mylene Farias

%
% Ler a imagem lena 

[x,map]=imread('lena512color.tiff');

% mostra as variaveis
whos
% voce deve ver que x eh uma imagem de 512x512x3 
% map eh o mapa de cores com valores entre 0 e 1
disp('pressione qualquer tecla para continuar ...')
pause; clc;

% visualizar imagem
figure(1),set(1,'position',[1 180 400 380])  
imshow(x,map);     
axis image;    % adicionar eixos a imagem
disp('pressione qualquer tecla para continuar ...')
pause; clc;

% converter para tons de cinza

I=rgb2gray(x);
% i cont?m valores entre 0 e 1
% visualize a imagem em tons de cinza
figure(2),set(2,'position',[400 180 400 380])  % open a 2nd figure window
colormap('gray');  % set color map to 64 level gray scale image
imshow(I);
% 
disp('pressione qualquer tecla para continuar ...')
pause; clc;
% rotacionar a imagem
b=rot90(I);
figure(2),colormap('gray'),imagesc(b);
% 
disp('pressione qualquer tecla para continuar ...')
pause; clc;


% realizando equalizacao de histogramas

b=histeq(I);
figure(2),colormap('gray'),imshow(uint8(b));
% 
disp('pressione qualquer tecla para continuar ...')
pause; clc;


% adicionando ruido salt and pepper 
b=imnoise(I,'salt & pepper',0.05);
figure(2),imshow(b)

disp('pressione qualquer tecla para continuar ...')
pause; clc;

%  filtro passa-baixas
%    1  1  1  1  1
%    1  1  1  1  1 
%    1  1  1  1  1  
%    1  1  1  1  1 
%    1  1  1  1  1
%   para filtrar a imagem

hmask=[1 1 1 1 1;1 1 1 1 1; 1 1 1 1 1;1 1 1 1 1;1 1 1 1 1]*.04;
c=filter2(hmask,b);
figure(2),imshow(uint8(c))
% 
disp('pressione qualquer tecla para continuar ...')
pause; clc;

% filtro mediana
c=medfilt2(b);
figure(1),imshow(uint8(c))
pause

